{% extends "lab_7/layout/base.html" %}
{% block content %}
<section name="mahasiswa-list" id="mahasiswa-list">
    <div class="container">
        <div class="row">
            <div class="col-md-8 col-lg-8">
                <h2> Mahasiswa Fasilkom</h2>
                <span class="btn btn-xs btn-default pagination-btn" onClick="prevPage()">Prev</span>
                <span class="btn btn-xs btn-default pagination-btn" onClick="nextPage()">Next</span>
                <div class="list-group" id="mahasiswa-all-list">
                    {% if mahasiswa_list %}
                        {% for mahasiswa in mahasiswa_list %}
                            <a class="list-group-item clearfix">
                                {{ mahasiswa.nama }} ({{ mahasiswa.npm }})
                                <span class="pull-right">
                                    <span class="btn btn-xs btn-default" onClick="addFriend('{{ mahasiswa.nama }}', '{{ mahasiswa.npm }}')">
                                        Tambah sebagai teman
                                    </span>
                                </span>
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Opps!</strong> Tidak ada mahasiswa
                        </div>
                    {% endif %}
                </div>
            </div>
            <div class="col-lg-4">
                <h2> Teman Saya </h2>
                <div class="list-group" id="friend-list">
                    {% if friend_list %}
                        {% for friend in friend_list %}
                            <a class="list-group-item clearfix">
                                {{ friend.friend_name }} ({{ friend.npm }})
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Opps!</strong> Tidak ada teman
                        </div>
                    {% endif %}
                </div>
                <form id="add-friend" action="#">
                    {% csrf_token %}
                    <label for="field_npm">npm</label>
                    <input id="field_npm" type="text" name="npm" class="form-control"/>
                    <label for="field_name">name</label>
                    <input id="field_name" type="text" name="name" class="form-control"/>
                    <button type="submit">Tambah</button>
                </form>
            </div>
        </div>
    </div>
</section>
{% endblock %}

{% block javascript %}
<script>
    var page = {{ current_page }};
    var addFriend = function(nama, npm) {
        $.ajax({
            method: "POST",
            url: "{% url "lab-7:add-friend" %}",
            data: { name: nama, npm: npm},
            success : function (friend) {
                friend = JSON.parse(friend)
                html = '<a class="list-group-item clearfix">' +
                    friend.friend_name + ' (' + friend.npm +') </a>';
                $("#friend-list").append(html)
            },
            error : function (error) {
                alert("Mahasiswa tersebut sudah ditambahkan sebagai teman")
            }
        });
    };
    
    var prevPage = function() {
        page--;
        changePage(page);
    };

    var nextPage = function() {
        page++;
        changePage(page);
    };
    
    var changePage = function(page) {
    $.ajax({
        method: "POST",
        url: '{% url "lab-7:change-page" %}',
        data: {'page': page},
        dataType: 'json',
        success: function (response) {
            $("#mahasiswa-all-list").empty();
            window.history.pushState("", "LAB 7", '{% url "lab-7:index" %}' + '?page=' + page);
            
            listOfMhs = JSON.parse(response.listOfMhs);
            for (mhs in listOfMhs) {
                m = listOfMhs[mhs];
                html = '<a class="list-group-item clearfix">' + 
                                m.nama + ' (' + m.npm + ')' +
                                '<span class="pull-right">' + 
                                '<span class="btn btn-xs btn-default" onClick="addFriend(' + 
                                "'" + m.nama + "', '" + m.npm + "'" + ')">Tambah sebagai teman</span></span></a>';
                $("#mahasiswa-all-list").append(html);
            }
        },
    });
    };
    
    $("#add-friend").on("submit", function () {
       name = $("#field_name").val()
       npm = $("#field_npm").val()
       kota_lahir = $("#field_kota_lahir").val()
        addFriend(name, npm, kota_lahir)
        event.preventDefault();
    });

    $("#field_npm").change(function () {
        console.log( $(this).val() );
        npm = $(this).val();
        $.ajax({
            method: "POST",
            url: '{% url "lab-7:validate-npm" %}',
            data: {
                'npm': npm
            },
            dataType: 'json',
            success: function (data) {
                console.log(data)
                if (data.is_taken) {
                    alert("Mahasiswa dengan npm seperti ini sudah ada");
                }
            }
        });
    });
</script>
{% endblock %}
